> For the complete documentation index, see [llms.txt](https://docs.stoobly.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stoobly.com/experimental/experimental-features/api-testing/configuration/lifecycle-hooks.md).

# Lifecycle Hooks

{% hint style="info" %}
**Use Case**

* Extend or override existing functionality
  {% endhint %}

## General Hooks

### Before Test

```python
def handle_before_test(context: TestContext):
    pass
```

### After Test

```python
def handle_after_test(context: TestContext):
    pass
```

## On Traverse Hooks

### Length Matches

```python
def handle_length_matches(context: MatchContext, v1: list, v2: list):
    pass
```

### Value Matches

```python
def handle_value_matches(context: MatchContext, v1, v2):
    pass
```

### Value Fuzzy Matches

```python
def handle_value_fuzzy_matches(context: MatchContext, v1, v2):
    pass
```

### Param Name Exists

```python
def handle_param_name_exists(context: MatchContext, key: str, actual: dict):
    pass
```

### Value Type Exists

```python
def handle_value_type_exists(context: MatchContext, value, valid_types: list):
    pass
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stoobly.com/experimental/experimental-features/api-testing/configuration/lifecycle-hooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
